# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
if sys.version_info < (2, 7) or (3, 0) <= sys.version_info < (3, 1):
    import simplejson as json
    from simplejson import OrderedDict
else:
    import json
    from collections import OrderedDict
import youku


def play(title, url):
    listitem = xbmcgui.ListItem(title)
    xbmc.Player().play(url, listitem)


def resp(ret):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        for elem in ret:
            resp(elem)
        return xbmcplugin.endOfDirectory(handle)
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
        if isinstance(ret['url'], dict):
            for k, v in ret['url'].items():
                resp({'title': ret['title'], 'url': v, 'format': k})
            return xbmcplugin.endOfDirectory(handle)
    t = sub1(ret['url'])
    if 'format' in ret:
        li = xbmcgui.ListItem(ret['format'])
        t = False
    else:
        li = xbmcgui.ListItem(ret['title'])
    if 'url' in ret:
        if ret['url'][:8] == 'stack://':
            return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8'):
            return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
        t = sub1(ret['url'])
    for k in ret:
        if isinstance(ret[k], unicode):
            ret[k] = ret[k].encode('utf-8')
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    if o.netloc == 'www.youku.com':
        if p[1] == 'show_page':
            return resp(youku.show_page(url))
        if p[1] == 'show_episode':
            return resp(youku.show_episode(url))
        if p[1] == 'playlist_show':
            return resp(youku.playlist_show(url))
    if o.netloc == 'v.youku.com':
        if p[1] == 'v_show' and p[2][:3] == 'id_':
            return resp(youku.play(url))
    if o.netloc == 'list.youku.com':
        if p[1] == 'show' and p[2][:3] == 'id_':
            return resp(youku.list_show_id(url))
        if p[1] == 'show' and p[2] == 'episode':
            return resp(youku.list_show_episode(url))
    return resp({'code': 'youku 020', 'error': url})


def sub3(content):
    try:
        data = json.loads(content, object_pairs_hook=OrderedDict)
    except Exception as e:
        return resp({'code': 'youku 030', 'error': str(e)})
    for k, v in data.items():
        if isinstance(v, dict):
            resp({'title': k, 'json': json.dumps(v)})
        else:
            resp({'title': k, 'url': v})
    xbmcplugin.endOfDirectory(handle)


def get_node(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return resp({'code': 'youku 010', 'error': str(e)})
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    get_node('http://ims.tian-le.com/youku.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'format' in q:
        play(q['title'][0], q['url'][0])
    elif 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
